﻿--[[
	This file is part of AutoRole.
	
	Copyright 2012 Matthew DeWitt Casey

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

		http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
]]
AutoRole = LibStub("AceAddon-3.0"):NewAddon("AutoRole", "AceConsole-3.0", "AceEvent-3.0")

local AUTOROLE_VERSION = GetAddOnMetadata("AutoRole", "X-Curse-Packaged-Version")

function AutoRole:OnInitialize()
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED", "SetRole")
	self:RegisterEvent("GROUP_ROSTER_UPDATE", "SetRole")
	RolePollPopup:SetScript("OnShow", function() RolePollPopupAcceptButton:Click() end)
end

function AutoRole:OnEnable()
	self:RegisterChatCommand("AR", "SlashCommand")
	self:RegisterChatCommand("AUTOROLE", "SlashCommand")
	self:Print(AUTOROLE_VERSION)
end

function AutoRole:OnDisable()
	
end

function AutoRole:SetRole(event)
	local currentSpec = GetSpecialization()
	if (currentSpec == nil) then
		UnitSetRole("player", "NONE")
		if (event == nil) then
			self:Print("Role set to NONE because you have no specialization.")
		end
	else
		local currentRole = GetSpecializationRole(currentSpec)
		local currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec))
		UnitSetRole("player", currentRole)
		if (event == nil) then
			self:Print("Role set to", currentRole, "because your specialization is", currentSpecName)
		end
	end
end

function AutoRole:SlashCommand(input)
	if input == "version" then
		self:Print(AUTOROLE_VERSION)
	elseif input == "showrole" then
		self:SetRole()
	else
		self:Print("/ar showrole")
		self:Print("/ar version")
	end
end